﻿Imports System.Drawing.Imaging
Imports System.Runtime.InteropServices

Module Module_ImageOperations

    Friend GrayBitmap As Bitmap
    Friend LoadedBitmap As Bitmap

    Friend Sub Image_Open()
        ' ---------------------------------------------
        Form1.Text = AppTitleAndVersion() + " - " + _
                     IO.Path.GetFileName(ImageFile)
        ' ---------------------------------------------
        Try
            LoadedBitmap = New Bitmap(ImageFile)
        Catch
            LoadedBitmap = Nothing
            Return
        End Try
        ' --------------------------------------------- resolution
        Form1.lbl_Resolution.Text = LoadedBitmap.Width.ToString + " x " + LoadedBitmap.Height.ToString
        ' --------------------------------------------- convert to 24 bits per pixel
        LoadedBitmap = BmpChangeTo24Bit(LoadedBitmap)
        ' --------------------------------------------- gray
        ProcessImage_Gray(LoadedBitmap)
        GrayBitmap = LoadedBitmap
        ' --------------------------------------------- 
        Form1.Pbox1.BackgroundImage = GrayBitmap
    End Sub

    Friend Sub Image_Modify(Optional ByVal Resolution As Int32 = 0, Optional ByVal Blur As Single = 0)
        '
        If LoadedBitmap Is Nothing Then
            Form1.Pbox1.BackgroundImage = Nothing
            Return
        End If
        '
        Dim bmp As Bitmap = CType(LoadedBitmap.Clone, Bitmap)
        '' --------------------------------------------- resize
        'If Resolution > 0 Then
        '    ResizeBitmap(bmp, Resolution)
        'End If
        '' --------------------------------------------- blur
        'BlurBitmap(bmp, Blur)
        ' ---------------------------------------------
        GrayBitmap = bmp
    End Sub



    '    ' ========================================================================================================
    '    '   BITMAP to/from BINARY ARRAY  ( Binary Array is inflated with a white border )
    '    ' ========================================================================================================

    '    Friend Sub Bitmap_to_BinaryArray(ByVal Bmp As Bitmap, ByRef ba As Boolean(,), ByVal Threshold As Integer)
    '        '
    '        ' -------------------------------------------------------------- inflated Result Array
    '        ReDim ba(Bmp.Width + 1, Bmp.Height + 1)
    '        '
    '        ' -------------------------------------------------------------- Fill inflated array
    '        Dim H As Int32 = Bmp.Height
    '        Dim W As Int32 = Bmp.Width
    '        Dim BmpData As BitmapData = Bmp.LockBits(New Rectangle(0, 0, W, H), _
    '                                                 ImageLockMode.ReadOnly, _
    '                                                 PixelFormat.Format24bppRgb)
    '        Dim Stride As Int32 = BmpData.Stride
    '        Dim BmpPtr As IntPtr = BmpData.Scan0
    '        Dim dxy As Int32
    '        Dim dy As Int32 = 0
    '        For y As Int32 = 0 To H - 1
    '            dxy = dy
    '            For x As Int32 = 0 To W - 1
    '                Dim b As Byte = Marshal.ReadByte(BmpPtr, dxy + 0)
    '                Dim g As Byte = Marshal.ReadByte(BmpPtr, dxy + 1)
    '                Dim r As Byte = Marshal.ReadByte(BmpPtr, dxy + 2)
    '                If GrayFromColors(r, g, b) < Threshold Then
    '                    ba(x + 1, y + 1) = True
    '                Else
    '                    ba(x + 1, y + 1) = False
    '                End If
    '                dxy += 3
    '            Next
    '            dy = dy + Stride
    '        Next
    '        Bmp.UnlockBits(BmpData)
    '        '
    '        ' -------------------------------------------------------------- Add a white Border
    '        For x As Integer = 0 To ba.GetLength(0) - 1
    '            ba(x, 0) = False
    '            ba(x, ba.GetLength(1) - 1) = False
    '        Next
    '        For y As Integer = 0 To ba.GetLength(1) - 1
    '            ba(0, y) = False
    '            ba(ba.GetLength(0) - 1, y) = False
    '        Next
    '    End Sub

    '    Friend Sub BinaryArray_to_Bitmap(ByVal ba As Boolean(,), ByRef Bmp As Bitmap)
    '        '
    '        ' -------------------------------------------------- -2 to ignore the border
    '        Dim W As Int32 = ba.GetLength(0) - 2
    '        Dim H As Int32 = ba.GetLength(1) - 2

    '        Bmp = New Bitmap(W, H)
    '        Dim BmpData As BitmapData = Bmp.LockBits(New Rectangle(0, 0, W, H), _
    '                                                  ImageLockMode.WriteOnly, _
    '                                                  PixelFormat.Format24bppRgb)
    '        Dim Stride As Int32 = BmpData.Stride
    '        Dim BmpPtr As IntPtr = BmpData.Scan0
    '        Dim dxy As Int32
    '        Dim dy As Int32 = 0
    '        For y As Int32 = 0 To H - 1
    '            dxy = dy
    '            For x As Int32 = 0 To W - 1
    '                ' ------------------------------ test i+1 and j+1 to ignore the border
    '                If ba(x + 1, y + 1) Then
    '                    Marshal.WriteByte(BmpPtr, dxy + 0, 0)
    '                    Marshal.WriteByte(BmpPtr, dxy + 1, 0)
    '                    Marshal.WriteByte(BmpPtr, dxy + 2, 0)
    '                Else
    '                    Marshal.WriteByte(BmpPtr, dxy + 0, 255)
    '                    Marshal.WriteByte(BmpPtr, dxy + 1, 255)
    '                    Marshal.WriteByte(BmpPtr, dxy + 2, 255)
    '                End If
    '                dxy += 3
    '            Next
    '            dy = dy + Stride
    '        Next
    '        Bmp.UnlockBits(BmpData)
    '    End Sub



    '    ' ========================================================================================================
    '    '   BITMAP to/from BYTE ARRAY  ( ByteArray is inflated with a white border )
    '    ' ========================================================================================================

    '    Friend Sub Bitmap_to_ByteArray(ByVal Bmp As Bitmap, ByRef ba As Byte(,), ByVal Threshold As Integer)
    '        '
    '        ' -------------------------------------------------------------- inflated Result Array
    '        ReDim ba(Bmp.Width + 1, Bmp.Height + 1)
    '        '
    '        ' -------------------------------------------------------------- Fill inflated array
    '        Dim H As Int32 = Bmp.Height
    '        Dim W As Int32 = Bmp.Width
    '        Dim BmpData As BitmapData = Bmp.LockBits(New Rectangle(0, 0, W, H), _
    '                                                 ImageLockMode.ReadOnly, _
    '                                                 PixelFormat.Format24bppRgb)
    '        Dim Stride As Int32 = BmpData.Stride
    '        Dim BmpPtr As IntPtr = BmpData.Scan0
    '        Dim dxy As Int32
    '        Dim dy As Int32 = 0
    '        For y As Int32 = 0 To H - 1
    '            dxy = dy
    '            For x As Int32 = 0 To W - 1
    '                Dim b1 As Byte = Marshal.ReadByte(BmpPtr, dxy + 0)
    '                Dim b2 As Byte = Marshal.ReadByte(BmpPtr, dxy + 1)
    '                Dim b3 As Byte = Marshal.ReadByte(BmpPtr, dxy + 2)
    '                If Math.Max(Math.Max(b1, b2), b3) < Threshold Then
    '                    ba(x + 1, y + 1) = 1
    '                Else
    '                    ba(x + 1, y + 1) = 0
    '                End If
    '                dxy += 3
    '            Next
    '            dy = dy + Stride
    '        Next
    '        Bmp.UnlockBits(BmpData)
    '        '
    '        ' -------------------------------------------------------------- Add a white Border
    '        For x As Integer = 0 To ba.GetLength(0) - 1
    '            ba(x, 0) = 0
    '            ba(x, ba.GetLength(1) - 1) = 0
    '        Next
    '        For y As Integer = 0 To ba.GetLength(1) - 1
    '            ba(0, y) = 0
    '            ba(ba.GetLength(0) - 1, y) = 0
    '        Next
    '    End Sub

    '    Friend Sub ByteArray_to_Bitmap(ByVal ba As Byte(,), ByRef Bmp As Bitmap)
    '        '
    '        ' -------------------------------------------------- -2 to ignore the border
    '        Dim W As Int32 = ba.GetLength(0) - 2
    '        Dim H As Int32 = ba.GetLength(1) - 2
    '        ' ----------------------------------------------------------------------- get bitmap data
    '        Dim BmpData As BitmapData = Bmp.LockBits(New Rectangle(0, 0, W, H), _
    '                                                  ImageLockMode.WriteOnly, _
    '                                                  PixelFormat.Format24bppRgb)
    '        ' ----------------------------------------------------------------------- fill the bitmap
    '        Dim Stride As Int32 = BmpData.Stride
    '        Dim BmpPtr As IntPtr = BmpData.Scan0
    '        Dim dxy As Int32
    '        Dim dy As Int32 = 0
    '        For y As Int32 = 0 To H - 1
    '            dxy = dy
    '            For x As Int32 = 0 To W - 1
    '                ' ------------------------------ test i+1 and j+1 to ignore the border
    '                If ba(x + 1, y + 1) <> 0 Then
    '                    Marshal.WriteByte(BmpPtr, dxy + 0, 0)
    '                    Marshal.WriteByte(BmpPtr, dxy + 1, 0)
    '                    Marshal.WriteByte(BmpPtr, dxy + 2, 0)
    '                Else
    '                    Marshal.WriteByte(BmpPtr, dxy + 0, 255)
    '                    Marshal.WriteByte(BmpPtr, dxy + 1, 255)
    '                    Marshal.WriteByte(BmpPtr, dxy + 2, 255)
    '                End If
    '                dxy += 3
    '            Next
    '            dy = dy + Stride
    '        Next
    '        Bmp.UnlockBits(BmpData)
    '    End Sub


    ' ========================================================================================================
    '   GRAY BITMAP to BYTE ARRAY  ( ByteArray is inflated with a white border )
    ' ========================================================================================================
    'Friend Sub GrayBitmap_to_ByteArray(ByVal Bmp As Bitmap, ByRef ba As Byte(,))
    '    '
    '    If Bmp Is Nothing Then Return

    '    ' -------------------------------------------------------------- inflated Result Array
    '    ReDim ba(Bmp.Width + 1, Bmp.Height + 1)
    '    '
    '    ' -------------------------------------------------------------- Fill inflated array
    '    Dim H As Int32 = Bmp.Height
    '    Dim W As Int32 = Bmp.Width
    '    Dim BmpData As BitmapData = Bmp.LockBits(New Rectangle(0, 0, W, H), _
    '                                             ImageLockMode.ReadOnly, _
    '                                             PixelFormat.Format24bppRgb)
    '    Dim Stride As Int32 = BmpData.Stride
    '    Dim BmpPtr As IntPtr = BmpData.Scan0
    '    Dim dxy As Int32
    '    Dim dy As Int32 = 0
    '    For y As Int32 = 0 To H - 1
    '        dxy = dy
    '        For x As Int32 = 0 To W - 1
    '            Dim b1 As Byte = Marshal.ReadByte(BmpPtr, dxy + 0)
    '            Dim b2 As Byte = Marshal.ReadByte(BmpPtr, dxy + 1)
    '            Dim b3 As Byte = Marshal.ReadByte(BmpPtr, dxy + 2)
    '            ba(x + 1, y + 1) = b1
    '            dxy += 3
    '        Next
    '        dy = dy + Stride
    '    Next
    '    Bmp.UnlockBits(BmpData)
    '    '
    '    ' -------------------------------------------------------------- Add a white Border
    '    For x As Integer = 0 To ba.GetLength(0) - 1
    '        ba(x, 0) = 0
    '        ba(x, ba.GetLength(1) - 1) = 0
    '    Next
    '    For y As Integer = 0 To ba.GetLength(1) - 1
    '        ba(0, y) = 0
    '        ba(ba.GetLength(0) - 1, y) = 0
    '    Next
    'End Sub



    ' ========================================================================================================
    '   GRAY BITMAP to BYTE ARRAY  ( ByteArray is inflated with a white border )
    ' ========================================================================================================
    Friend Sub GrayBitmap_to_ByteArray(ByVal Bmp As Bitmap, ByRef ba As Byte(,))
        '
        If Bmp Is Nothing Then Return
        ' -------------------------------------------------------------- Dim Array
        Dim H As Int32 = Bmp.Height
        Dim W As Int32 = Bmp.Width
        ReDim ba(W - 1, H - 1)
        '
        ' -------------------------------------------------------------- Fill array
        Dim BmpData As BitmapData = Bmp.LockBits(New Rectangle(0, 0, W, H), _
                                                 ImageLockMode.ReadOnly, _
                                                 PixelFormat.Format24bppRgb)
        Dim Stride As Int32 = BmpData.Stride
        Dim BmpPtr As IntPtr = BmpData.Scan0
        Dim dxy As Int32
        Dim dy As Int32 = 0
        For y As Int32 = 0 To H - 1
            dxy = dy
            For x As Int32 = 0 To W - 1
                Dim b1 As Byte = Marshal.ReadByte(BmpPtr, dxy + 0)
                Dim b2 As Byte = Marshal.ReadByte(BmpPtr, dxy + 1)
                Dim b3 As Byte = Marshal.ReadByte(BmpPtr, dxy + 2)
                ba(x, y) = b1
                dxy += 3
            Next
            dy = dy + Stride
        Next
        Bmp.UnlockBits(BmpData)
    End Sub

End Module
